
#ifndef INTRO_SCREEN_HPP
#define INTRO_SCREEN_HPP

#include <NDS/jtypes.h>
#include "Backgrounds.hpp"

class IntroScreen {
public:
  /**
   * @brief
   * Constructor is only called once ever.
   **/
  IntroScreen(const uint16* appData, uint32 sizeof_appData,
	      const uint16* appPalette, uint32 sizeof_appPalette,
	      const uint16* appMap = 0);
  /**
   * @brief
   * prepare is called before each invocation of the intro screen
   * sequence.
   **/
  void prepare(void);

  /**
   * @brief
   * @retval true Continue to call this updateDisplay.
   * @retval false This screen sequence is complete.
   **/
  bool updateDisplay(void);
private:
  BackgroundMap _main;
  BackgroundMap _sub;

  uint32 update_counter;
  const uint16* _appMap;

  static const int _tile_base;
  static const int _map_base;

  /**
   * @brief
   * Number of update calls to display the introduction screen.
   * Seconds = _display_time / 60.
   **/
  static const unsigned int _display_time;
};

#endif
