
#ifndef TITLE_SCREEN_HPP
#define TITLE_SCREEN_HPP

#include "Backgrounds.hpp"
#include "Sprites.hpp"

struct SongData {
  const uint16* _songData;
  Sprite _spr[8];
};

class TitleScreen : public SpritesBase {
public:
  /**
   * @brief
   * Constructor is only called once ever.
   **/
  TitleScreen();
  /**
   * @brief
   * prepare is called before each invocation of the intro screen
   * sequence.
   **/
  void prepare(void);

  /**
   * @brief
   * @retval true Continue to call this updateDisplay.
   * @retval false This screen sequence is complete.
   **/
  bool updateDisplay(void);

private:
  BackgroundMap _main;
  BackgroundMap _sub;
  SongData _song_data[6];

  uint32 sub_bg_colors;
  uint32 bg_colors;

  uint32 _update_counter;

  static const int _tile_base;
  static const int _map_base;
};

#endif
