

#ifndef UTILS_HPP
#define UTILS_HPP

#include <NDS/jtypes.h>

#ifndef NULL
#define NULL (0)
#endif

/**
 * @brief
 * Copy bytes from one place to another a byte at a time.
 *
 * @param src The source memory that is being copied.
 * @param dest The destination memory of the data.
 * @param size The number of bytes to copy.
 *
 * @retval next_dest The next byte of location where data should be
 *         written.
 **/
uint8* copy8(uint8* src, uint8* dest, uint32 size);

/**
 * @brief
 * Copy a null-terminated array of bytes from one place to another a
 * byte at a time.  The null is copied.
 *
 * @param src The source memory that is being copied.
 * @param dest The destination memory of the data.
 *
 * @retval next_dest The next byte of location where data should be
 *         written.
 **/
uint8* copy8null(uint8* src, uint8* dest);

#endif
